#ifndef H_CLOK
#define H_CLOK
//
// A simple stopwatch class for performance measurements
//

#include <string>

class Clok { 
    int n;
    double
        w,u,s, // accumulated totals 
        sw,su,ss; // start times
public:
    Clok(): n(0), w(0.), u(0.), s(0.) { }
    static void wall( double & ); 
    static void user_sys( double &, double & );
    inline void start() { n++; wall(sw); user_sys(su,ss); }
    inline void stop() { double ew, eu, es; wall(ew); user_sys(eu,es); w += ew-sw; u += eu-su; s += 
es-ss; }
    inline std::string report() const { 
        char buffer[ 80 ];
        sprintf( buffer, "n %d wall %8g user %8g sys %8g", n, w, u, s );
        return std::string( buffer );
    }
    inline double getWall() { return double( w ); }
    inline double getUser() { return double( u ); }
    inline double getSys() { return double( s ); }
}; 




#endif

